Index: lemon/concepts/graph_components.h
===================================================================
--- lemon/concepts/graph_components.h	(revision 576)
+++ lemon/concepts/graph_components.h	(revision 550)
@@ -687,24 +675,24 @@
       /// \brief The base node of the iterator.
       ///
-      /// This function gives back the base node of the iterator.
-      /// It is always the target node of the pointed arc.
+      /// Gives back the base node of the iterator.
+      /// It is always the target of the pointed arc.
       Node baseNode(const InArcIt&) const { return INVALID; }
 
       /// \brief The running node of the iterator.
       ///
-      /// This function gives back the running node of the iterator.
-      /// It is always the source node of the pointed arc.
+      /// Gives back the running node of the iterator.
+      /// It is always the source of the pointed arc.
       Node runningNode(const InArcIt&) const { return INVALID; }
 
       /// \brief The base node of the iterator.
       ///
-      /// This function gives back the base node of the iterator.
-      /// It is always the source node of the pointed arc.
+      /// Gives back the base node of the iterator.
+      /// It is always the source of the pointed arc.
       Node baseNode(const OutArcIt&) const { return INVALID; }
 
       /// \brief The running node of the iterator.
       ///
-      /// This function gives back the running node of the iterator.
-      /// It is always the target node of the pointed arc.
+      /// Gives back the running node of the iterator.
+      /// It is always the target of the pointed arc.
       Node runningNode(const OutArcIt&) const { return INVALID; }
 
@@ -748,10 +736,10 @@
 
             typename _Digraph::Node n;
-            const typename _Digraph::InArcIt iait(INVALID);
-            const typename _Digraph::OutArcIt oait(INVALID);
-            n = digraph.baseNode(iait);
-            n = digraph.runningNode(iait);
-            n = digraph.baseNode(oait);
-            n = digraph.runningNode(oait);
+            typename _Digraph::InArcIt ieit(INVALID);
+            typename _Digraph::OutArcIt oeit(INVALID);
+            n = digraph.baseNode(ieit);
+            n = digraph.runningNode(ieit);
+            n = digraph.baseNode(oeit);
+            n = digraph.runningNode(oeit);
             ignore_unused_variable_warning(n);
           }
@@ -759,12 +747,12 @@
 
         const _Digraph& digraph;
-      };
-    };
-
-    /// \brief Skeleton class for iterable undirected graphs.
-    ///
-    /// This class describes the interface of iterable undirected
-    /// graphs. It extends \ref IterableDigraphComponent with the core
-    /// iterable interface of undirected graphs.
+
+      };
+    };
+
+    /// \brief An empty iterable undirected graph class.
+    ///
+    /// This class provides beside the core graph features iterator
+    /// based iterable interface for the undirected graph structure.
     /// This concept is part of the Graph concept.
     template <typename BAS = BaseGraphComponent>
@@ -780,8 +768,7 @@
       typedef IterableGraphComponent Graph;
 
-      /// \name Base Iteration
-      ///
-      /// This interface provides functions for iteration on edges.
-      ///
+      /// \name Base iteration
+      ///
+      /// This interface provides functions for iteration on graph items
       /// @{
 
@@ -789,20 +776,26 @@
       using IterableDigraphComponent<Base>::next;
 
-      /// \brief Return the first edge.
-      ///
-      /// This function gives back the first edge in the iteration order.
+      /// \brief Gives back the first edge in the iterating
+      /// order.
+      ///
+      /// Gives back the first edge in the iterating order.
+      ///
       void first(Edge&) const {}
 
-      /// \brief Return the next edge.
-      ///
-      /// This function gives back the next edge in the iteration order.
+      /// \brief Gives back the next edge in the iterating
+      /// order.
+      ///
+      /// Gives back the next edge in the iterating order.
+      ///
       void next(Edge&) const {}
 
-      /// \brief Return the first edge incident to the given node.
-      ///
-      /// This function gives back the first edge incident to the given 
-      /// node. The bool parameter gives back the direction for which the
-      /// source node of the directed arc representing the edge is the 
+
+      /// \brief Gives back the first of the edges from the
       /// given node.
+      ///
+      /// Gives back the first of the edges from the given
+      /// node. The bool parameter gives back that direction which
+      /// gives a good direction of the edge so the source of the
+      /// directed arc is the given node.
       void firstInc(Edge&, bool&, const Node&) const {}
 
@@ -810,6 +803,7 @@
       /// given node.
       ///
-      /// This function gives back the next edge incident to the given 
-      /// node. The bool parameter should be used as \c firstInc() use it.
+      /// Gives back the next of the edges from the given
+      /// node. The bool parameter should be used as the \c firstInc()
+      /// use it.
       void nextInc(Edge&, bool&) const {}
 
@@ -819,30 +813,28 @@
       /// @}
 
-      /// \name Class Based Iteration
-      ///
-      /// This interface provides iterator classes for edges.
+      /// \name Class based iteration
+      ///
+      /// This interface provides functions for iteration on graph items
       ///
       /// @{
 
-      /// \brief This iterator goes through each edge.
-      ///
-      /// This iterator goes through each edge.
+      /// \brief This iterator goes through each node.
+      ///
+      /// This iterator goes through each node.
       typedef GraphItemIt<Graph, Edge> EdgeIt;
-
-      /// \brief This iterator goes trough the incident edges of a
+      /// \brief This iterator goes trough the incident arcs of a
       /// node.
       ///
-      /// This iterator goes trough the incident edges of a certain
+      /// This iterator goes trough the incident arcs of a certain
       /// node of a graph.
-      typedef GraphIncIt<Graph, Edge, Node, 'e'> IncEdgeIt;
-
+      typedef GraphIncIt<Graph, Edge, Node, 'u'> IncEdgeIt;
       /// \brief The base node of the iterator.
       ///
-      /// This function gives back the base node of the iterator.
+      /// Gives back the base node of the iterator.
       Node baseNode(const IncEdgeIt&) const { return INVALID; }
 
       /// \brief The running node of the iterator.
       ///
-      /// This function gives back the running node of the iterator.
+      /// Gives back the running node of the iterator.
       Node runningNode(const IncEdgeIt&) const { return INVALID; }
 
@@ -873,10 +865,10 @@
               typename _Graph::EdgeIt >();
             checkConcept<GraphIncIt<_Graph, typename _Graph::Edge,
-              typename _Graph::Node, 'e'>, typename _Graph::IncEdgeIt>();
+              typename _Graph::Node, 'u'>, typename _Graph::IncEdgeIt>();
 
             typename _Graph::Node n;
-            const typename _Graph::IncEdgeIt ieit(INVALID);
-            n = graph.baseNode(ieit);
-            n = graph.runningNode(ieit);
+            typename _Graph::IncEdgeIt ueit(INVALID);
+            n = graph.baseNode(ueit);
+            n = graph.runningNode(ueit);
           }
         }
@@ -886,12 +878,11 @@
     };
 
-    /// \brief Skeleton class for alterable directed graphs.
-    ///
-    /// This class describes the interface of alterable directed
-    /// graphs. It extends \ref BaseDigraphComponent with the alteration
-    /// notifier interface. It implements
+    /// \brief An empty alteration notifier digraph class.
+    ///
+    /// This class provides beside the core digraph features alteration
+    /// notifier interface for the digraph structure.  This implements
     /// an observer-notifier pattern for each digraph item. More
     /// obsevers can be registered into the notifier and whenever an
-    /// alteration occured in the digraph all the observers will be
+    /// alteration occured in the digraph all the observers will
     /// notified about it.
     template <typename BAS = BaseDigraphComponent>
@@ -904,21 +895,21 @@
 
 
-      /// Node alteration notifier class.
+      /// The node observer registry.
       typedef AlterationNotifier<AlterableDigraphComponent, Node>
       NodeNotifier;
-      /// Arc alteration notifier class.
+      /// The arc observer registry.
       typedef AlterationNotifier<AlterableDigraphComponent, Arc>
       ArcNotifier;
 
-      /// \brief Return the node alteration notifier.
-      ///
-      /// This function gives back the node alteration notifier.
+      /// \brief Gives back the node alteration notifier.
+      ///
+      /// Gives back the node alteration notifier.
       NodeNotifier& notifier(Node) const {
-         return NodeNotifier();
+        return NodeNotifier();
       }
 
-      /// \brief Return the arc alteration notifier.
-      ///
-      /// This function gives back the arc alteration notifier.
+      /// \brief Gives back the arc alteration notifier.
+      ///
+      /// Gives back the arc alteration notifier.
       ArcNotifier& notifier(Arc) const {
         return ArcNotifier();
@@ -940,15 +931,16 @@
 
         const _Digraph& digraph;
-      };
-    };
-
-    /// \brief Skeleton class for alterable undirected graphs.
-    ///
-    /// This class describes the interface of alterable undirected
-    /// graphs. It extends \ref AlterableDigraphComponent with the alteration
-    /// notifier interface of undirected graphs. It implements
-    /// an observer-notifier pattern for the edges. More
+
+      };
+
+    };
+
+    /// \brief An empty alteration notifier undirected graph class.
+    ///
+    /// This class provides beside the core graph features alteration
+    /// notifier interface for the graph structure.  This implements
+    /// an observer-notifier pattern for each graph item. More
     /// obsevers can be registered into the notifier and whenever an
-    /// alteration occured in the graph all the observers will be
+    /// alteration occured in the graph all the observers will
     /// notified about it.
     template <typename BAS = BaseGraphComponent>
@@ -960,11 +952,11 @@
 
 
-      /// Edge alteration notifier class.
+      /// The arc observer registry.
       typedef AlterationNotifier<AlterableGraphComponent, Edge>
       EdgeNotifier;
 
-      /// \brief Return the edge alteration notifier.
-      ///
-      /// This function gives back the edge alteration notifier.
+      /// \brief Gives back the arc alteration notifier.
+      ///
+      /// Gives back the arc alteration notifier.
       EdgeNotifier& notifier(Edge) const {
         return EdgeNotifier();
@@ -974,5 +966,5 @@
       struct Constraints {
         void constraints() {
-          checkConcept<AlterableDigraphComponent<Base>, _Graph>();
+          checkConcept<AlterableGraphComponent<Base>, _Graph>();
           typename _Graph::EdgeNotifier& uen
             = graph.notifier(typename _Graph::Edge());
@@ -984,12 +976,11 @@
     };
 
-    /// \brief Concept class for standard graph maps.
-    ///
-    /// This class describes the concept of standard graph maps, i.e.
-    /// the \c NodeMap, \c ArcMap and \c EdgeMap subtypes of digraph and 
-    /// graph types, which can be used for associating data to graph items.
-    /// The standard graph maps must conform to the ReferenceMap concept.
+    /// \brief Class describing the concept of graph maps
+    ///
+    /// This class describes the common interface of the graph maps
+    /// (NodeMap, ArcMap), that is maps that can be used to
+    /// associate data to graph descriptors (nodes or arcs).
     template <typename GR, typename K, typename V>
-    class GraphMap : public ReferenceMap<K, V, V&, const V&> {
+    class GraphMap : public ReadWriteMap<K, V> {
     public:
 
@@ -1002,11 +993,4 @@
       /// The value type of the map.
       typedef V Value;
-      /// The reference type of the map.
-      typedef Value& Reference;
-      /// The const reference type of the map.
-      typedef const Value& ConstReference;
-
-      // The reference map tag.
-      typedef True ReferenceMapTag;
 
       /// \brief Construct a new map.
@@ -1016,5 +1000,5 @@
       /// \brief Construct a new map with default value.
       ///
-      /// Construct a new map for the graph and initalize the values.
+      /// Construct a new map for the graph and initalise the values.
       GraphMap(const Graph&, const Value&) {}
 
@@ -1025,7 +1009,7 @@
       GraphMap(const GraphMap&) : Parent() {}
 
-      /// \brief Assignment operator.
-      ///
-      /// Assignment operator. It does not mofify the underlying graph,
+      /// \brief Assign operator.
+      ///
+      /// Assign operator. It does not mofify the underlying graph,
       /// it just iterates on the current item set and set the  map
       /// with the value returned by the assigned map.
@@ -1040,22 +1024,21 @@
       struct Constraints {
         void constraints() {
-          checkConcept
-            <ReferenceMap<Key, Value, Value&, const Value&>, _Map>();
-          _Map m1(g);
-          _Map m2(g,t);
-          
-          // Copy constructor
-          // _Map m3(m);
-
-          // Assignment operator
+          checkConcept<ReadWriteMap<Key, Value>, _Map >();
+          // Construction with a graph parameter
+          _Map a(g);
+          // Constructor with a graph and a default value parameter
+          _Map a2(g,t);
+          // Copy constructor.
+          // _Map b(c);
+
           // ReadMap<Key, Value> cmap;
-          // m3 = cmap;
-
-          ignore_unused_variable_warning(m1);
-          ignore_unused_variable_warning(m2);
-          // ignore_unused_variable_warning(m3);
-        }
-
-        const _Map &m;
+          // b = cmap;
+
+          ignore_unused_variable_warning(a);
+          ignore_unused_variable_warning(a2);
+          // ignore_unused_variable_warning(b);
+        }
+
+        const _Map &c;
         const Graph &g;
         const typename GraphMap::Value &t;
@@ -1064,9 +1047,8 @@
     };
 
-    /// \brief Skeleton class for mappable directed graphs.
-    ///
-    /// This class describes the interface of mappable directed graphs.
-    /// It extends \ref BaseDigraphComponent with the standard digraph 
-    /// map classes, namely \c NodeMap and \c ArcMap.
+    /// \brief An empty mappable digraph class.
+    ///
+    /// This class provides beside the core digraph features
+    /// map interface for the digraph structure.
     /// This concept is part of the Digraph concept.
     template <typename BAS = BaseDigraphComponent>
@@ -1080,10 +1062,10 @@
       typedef MappableDigraphComponent Digraph;
 
-      /// \brief Standard graph map for the nodes.
-      ///
-      /// Standard graph map for the nodes.
-      /// It conforms to the ReferenceMap concept.
+      /// \brief ReadWrite map of the nodes.
+      ///
+      /// ReadWrite map of the nodes.
+      ///
       template <typename V>
-      class NodeMap : public GraphMap<MappableDigraphComponent, Node, V> {
+      class NodeMap : public GraphMap<Digraph, Node, V> {
       public:
         typedef GraphMap<MappableDigraphComponent, Node, V> Parent;
@@ -1097,5 +1079,5 @@
         /// \brief Construct a new map with default value.
         ///
-        /// Construct a new map for the digraph and initalize the values.
+        /// Construct a new map for the digraph and initalise the values.
         NodeMap(const MappableDigraphComponent& digraph, const V& value)
           : Parent(digraph, value) {}
@@ -1107,7 +1089,7 @@
         NodeMap(const NodeMap& nm) : Parent(nm) {}
 
-        /// \brief Assignment operator.
-        ///
-        /// Assignment operator.
+        /// \brief Assign operator.
+        ///
+        /// Assign operator.
         template <typename CMap>
         NodeMap& operator=(const CMap&) {
@@ -1118,10 +1100,10 @@
       };
 
-      /// \brief Standard graph map for the arcs.
-      ///
-      /// Standard graph map for the arcs.
-      /// It conforms to the ReferenceMap concept.
+      /// \brief ReadWrite map of the arcs.
+      ///
+      /// ReadWrite map of the arcs.
+      ///
       template <typename V>
-      class ArcMap : public GraphMap<MappableDigraphComponent, Arc, V> {
+      class ArcMap : public GraphMap<Digraph, Arc, V> {
       public:
         typedef GraphMap<MappableDigraphComponent, Arc, V> Parent;
@@ -1135,5 +1117,5 @@
         /// \brief Construct a new map with default value.
         ///
-        /// Construct a new map for the digraph and initalize the values.
+        /// Construct a new map for the digraph and initalise the values.
         ArcMap(const MappableDigraphComponent& digraph, const V& value)
           : Parent(digraph, value) {}
@@ -1145,7 +1127,7 @@
         ArcMap(const ArcMap& nm) : Parent(nm) {}
 
-        /// \brief Assignment operator.
-        ///
-        /// Assignment operator.
+        /// \brief Assign operator.
+        ///
+        /// Assign operator.
         template <typename CMap>
         ArcMap& operator=(const CMap&) {
@@ -1197,13 +1179,12 @@
         }
 
-        const _Digraph& digraph;
-      };
-    };
-
-    /// \brief Skeleton class for mappable undirected graphs.
-    ///
-    /// This class describes the interface of mappable undirected graphs.
-    /// It extends \ref MappableDigraphComponent with the standard graph 
-    /// map class for edges (\c EdgeMap).
+        _Digraph& digraph;
+      };
+    };
+
+    /// \brief An empty mappable base bipartite graph class.
+    ///
+    /// This class provides beside the core graph features
+    /// map interface for the graph structure.
     /// This concept is part of the Graph concept.
     template <typename BAS = BaseGraphComponent>
@@ -1216,10 +1197,10 @@
       typedef MappableGraphComponent Graph;
 
-      /// \brief Standard graph map for the edges.
-      ///
-      /// Standard graph map for the edges.
-      /// It conforms to the ReferenceMap concept.
+      /// \brief ReadWrite map of the edges.
+      ///
+      /// ReadWrite map of the edges.
+      ///
       template <typename V>
-      class EdgeMap : public GraphMap<MappableGraphComponent, Edge, V> {
+      class EdgeMap : public GraphMap<Graph, Edge, V> {
       public:
         typedef GraphMap<MappableGraphComponent, Edge, V> Parent;
@@ -1233,5 +1214,5 @@
         /// \brief Construct a new map with default value.
         ///
-        /// Construct a new map for the graph and initalize the values.
+        /// Construct a new map for the graph and initalise the values.
         EdgeMap(const MappableGraphComponent& graph, const V& value)
           : Parent(graph, value) {}
@@ -1243,7 +1224,7 @@
         EdgeMap(const EdgeMap& nm) : Parent(nm) {}
 
-        /// \brief Assignment operator.
-        ///
-        /// Assignment operator.
+        /// \brief Assign operator.
+        ///
+        /// Assign operator.
         template <typename CMap>
         EdgeMap& operator=(const CMap&) {
@@ -1265,5 +1246,5 @@
 
         void constraints() {
-          checkConcept<MappableDigraphComponent<Base>, _Graph>();
+          checkConcept<MappableGraphComponent<Base>, _Graph>();
 
           { // int map test
@@ -1282,14 +1263,14 @@
         }
 
-        const _Graph& graph;
-      };
-    };
-
-    /// \brief Skeleton class for extendable directed graphs.
-    ///
-    /// This class describes the interface of extendable directed graphs.
-    /// It extends \ref BaseDigraphComponent with functions for adding 
-    /// nodes and arcs to the digraph.
-    /// This concept requires \ref AlterableDigraphComponent.
+        _Graph& graph;
+      };
+    };
+
+    /// \brief An empty extendable digraph class.
+    ///
+    /// This class provides beside the core digraph features digraph
+    /// extendable interface for the digraph structure.  The main
+    /// difference between the base and this interface is that the
+    /// digraph alterations should handled already on this level.
     template <typename BAS = BaseDigraphComponent>
     class ExtendableDigraphComponent : public BAS {
@@ -1300,15 +1281,15 @@
       typedef typename Base::Arc Arc;
 
-      /// \brief Add a new node to the digraph.
-      ///
-      /// This function adds a new node to the digraph.
+      /// \brief Adds a new node to the digraph.
+      ///
+      /// Adds a new node to the digraph.
+      ///
       Node addNode() {
         return INVALID;
       }
 
-      /// \brief Add a new arc connecting the given two nodes.
-      ///
-      /// This function adds a new arc connecting the given two nodes
-      /// of the digraph.
+      /// \brief Adds a new arc connects the given two nodes.
+      ///
+      /// Adds a new arc connects the the given two nodes.
       Arc addArc(const Node&, const Node&) {
         return INVALID;
@@ -1330,10 +1311,11 @@
     };
 
-    /// \brief Skeleton class for extendable undirected graphs.
-    ///
-    /// This class describes the interface of extendable undirected graphs.
-    /// It extends \ref BaseGraphComponent with functions for adding 
-    /// nodes and edges to the graph.
-    /// This concept requires \ref AlterableGraphComponent.
+    /// \brief An empty extendable base undirected graph class.
+    ///
+    /// This class provides beside the core undirected graph features
+    /// core undircted graph extend interface for the graph structure.
+    /// The main difference between the base and this interface is
+    /// that the graph alterations should handled already on this
+    /// level.
     template <typename BAS = BaseGraphComponent>
     class ExtendableGraphComponent : public BAS {
@@ -1344,16 +1326,16 @@
       typedef typename Base::Edge Edge;
 
-      /// \brief Add a new node to the digraph.
-      ///
-      /// This function adds a new node to the digraph.
+      /// \brief Adds a new node to the graph.
+      ///
+      /// Adds a new node to the graph.
+      ///
       Node addNode() {
         return INVALID;
       }
 
-      /// \brief Add a new edge connecting the given two nodes.
-      ///
-      /// This function adds a new edge connecting the given two nodes
-      /// of the graph.
-      Edge addEdge(const Node&, const Node&) {
+      /// \brief Adds a new arc connects the given two nodes.
+      ///
+      /// Adds a new arc connects the the given two nodes.
+      Edge addArc(const Node&, const Node&) {
         return INVALID;
       }
@@ -1374,10 +1356,10 @@
     };
 
-    /// \brief Skeleton class for erasable directed graphs.
-    ///
-    /// This class describes the interface of erasable directed graphs.
-    /// It extends \ref BaseDigraphComponent with functions for removing 
-    /// nodes and arcs from the digraph.
-    /// This concept requires \ref AlterableDigraphComponent.
+    /// \brief An empty erasable digraph class.
+    ///
+    /// This class provides beside the core digraph features core erase
+    /// functions for the digraph structure. The main difference between
+    /// the base and this interface is that the digraph alterations
+    /// should handled already on this level.
     template <typename BAS = BaseDigraphComponent>
     class ErasableDigraphComponent : public BAS {
@@ -1390,11 +1372,12 @@
       /// \brief Erase a node from the digraph.
       ///
-      /// This function erases the given node from the digraph and all arcs 
-      /// connected to the node.
+      /// Erase a node from the digraph. This function should
+      /// erase all arcs connecting to the node.
       void erase(const Node&) {}
 
       /// \brief Erase an arc from the digraph.
       ///
-      /// This function erases the given arc from the digraph.
+      /// Erase an arc from the digraph.
+      ///
       void erase(const Arc&) {}
 
@@ -1403,7 +1386,7 @@
         void constraints() {
           checkConcept<Base, _Digraph>();
-          const typename _Digraph::Node node(INVALID);
+          typename _Digraph::Node node;
           digraph.erase(node);
-          const typename _Digraph::Arc arc(INVALID);
+          typename _Digraph::Arc arc;
           digraph.erase(arc);
         }
@@ -1413,10 +1396,10 @@
     };
 
-    /// \brief Skeleton class for erasable undirected graphs.
-    ///
-    /// This class describes the interface of erasable undirected graphs.
-    /// It extends \ref BaseGraphComponent with functions for removing 
-    /// nodes and edges from the graph.
-    /// This concept requires \ref AlterableGraphComponent.
+    /// \brief An empty erasable base undirected graph class.
+    ///
+    /// This class provides beside the core undirected graph features
+    /// core erase functions for the undirceted graph structure. The
+    /// main difference between the base and this interface is that
+    /// the graph alterations should handled already on this level.
     template <typename BAS = BaseGraphComponent>
     class ErasableGraphComponent : public BAS {
@@ -1429,11 +1412,12 @@
       /// \brief Erase a node from the graph.
       ///
-      /// This function erases the given node from the graph and all edges
-      /// connected to the node.
+      /// Erase a node from the graph. This function should erase
+      /// arcs connecting to the node.
       void erase(const Node&) {}
 
-      /// \brief Erase an edge from the digraph.
-      ///
-      /// This function erases the given edge from the digraph.
+      /// \brief Erase an arc from the graph.
+      ///
+      /// Erase an arc from the graph.
+      ///
       void erase(const Edge&) {}
 
@@ -1442,7 +1426,7 @@
         void constraints() {
           checkConcept<Base, _Graph>();
-          const typename _Graph::Node node(INVALID);
+          typename _Graph::Node node;
           graph.erase(node);
-          const typename _Graph::Edge edge(INVALID);
+          typename _Graph::Edge edge;
           graph.erase(edge);
         }
@@ -1452,10 +1436,10 @@
     };
 
-    /// \brief Skeleton class for clearable directed graphs.
-    ///
-    /// This class describes the interface of clearable directed graphs.
-    /// It extends \ref BaseDigraphComponent with a function for clearing
-    /// the digraph.
-    /// This concept requires \ref AlterableDigraphComponent.
+    /// \brief An empty clearable base digraph class.
+    ///
+    /// This class provides beside the core digraph features core clear
+    /// functions for the digraph structure. The main difference between
+    /// the base and this interface is that the digraph alterations
+    /// should handled already on this level.
     template <typename BAS = BaseDigraphComponent>
     class ClearableDigraphComponent : public BAS {
@@ -1466,5 +1450,6 @@
       /// \brief Erase all nodes and arcs from the digraph.
       ///
-      /// This function erases all nodes and arcs from the digraph.
+      /// Erase all nodes and arcs from the digraph.
+      ///
       void clear() {}
 
@@ -1476,14 +1461,14 @@
         }
 
-        _Digraph& digraph;
-      };
-    };
-
-    /// \brief Skeleton class for clearable undirected graphs.
-    ///
-    /// This class describes the interface of clearable undirected graphs.
-    /// It extends \ref BaseGraphComponent with a function for clearing
-    /// the graph.
-    /// This concept requires \ref AlterableGraphComponent.
+        _Digraph digraph;
+      };
+    };
+
+    /// \brief An empty clearable base undirected graph class.
+    ///
+    /// This class provides beside the core undirected graph features
+    /// core clear functions for the undirected graph structure. The
+    /// main difference between the base and this interface is that
+    /// the graph alterations should handled already on this level.
     template <typename BAS = BaseGraphComponent>
     class ClearableGraphComponent : public ClearableDigraphComponent<BAS> {
@@ -1492,17 +1477,11 @@
       typedef BAS Base;
 
-      /// \brief Erase all nodes and edges from the graph.
-      ///
-      /// This function erases all nodes and edges from the graph.
-      void clear() {}
-
       template <typename _Graph>
       struct Constraints {
         void constraints() {
-          checkConcept<Base, _Graph>();
-          graph.clear();
-        }
-
-        _Graph& graph;
+          checkConcept<ClearableGraphComponent<Base>, _Graph>();
+        }
+
+        _Graph graph;
       };
     };
Index: lemon/concepts/heap.h
===================================================================
--- lemon/concepts/heap.h	(revision 576)
+++ lemon/concepts/heap.h	(revision 550)
@@ -72,7 +72,7 @@
       /// \c PRE_HEAP (<tt>-1</tt>) to any element to be put in the heap.
       enum State {
-        IN_HEAP = 0,    ///< = 0. The "in heap" state constant.
-        PRE_HEAP = -1,  ///< = -1. The "pre heap" state constant.
-        POST_HEAP = -2  ///< = -2. The "post heap" state constant.
+        IN_HEAP = 0,    ///< The "in heap" state constant.
+        PRE_HEAP = -1,  ///< The "pre heap" state constant.
+        POST_HEAP = -2  ///< The "post heap" state constant.
       };
 
